// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSA/include/16ai32ssa_utils.h $
// $Rev: 51923 $
// $Date: 2022-10-20 17:35:05 -0500 (Thu, 20 Oct 2022) $

// 16AI32SSA: Utilities: header file

#ifndef	__16AI32SSA_UTILS_H__
#define	__16AI32SSA_UTILS_H__

#include "16ai32ssa_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	ai32ssa_close_util			(int fd, int index, int verbose);
int ai32ssa_init_util			(int verbose);
int ai32ssa_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	ai32ssa_open_util			(int device, int share, int index, int verbose, int* fd);
int	ai32ssa_read_util			(int fd, int index, int verbose, void* dst, size_t bytes);

// IOCTL utility services

int	ai32ssa_ain_buf_clear		(int fd, int index, int verbose);								// AI32SSA_IOCTL_AIN_BUF_CLEAR
int	ai32ssa_ain_buf_level		(int fd, int index, int verbose, s32* get);						// AI32SSA_IOCTL_AIN_BUF_LEVEL
int	ai32ssa_ain_buf_overflow	(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_AIN_BUF_OVERFLOW
int	ai32ssa_ain_buf_thr_lvl		(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_AIN_BUF_THR_LVL
int	ai32ssa_ain_buf_thr_sts		(int fd, int index, int verbose, s32* get);						// AI32SSA_IOCTL_AIN_BUF_THR_STS
int	ai32ssa_ain_buf_underflow	(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_AIN_BUF_UNDERFLOW
int	ai32ssa_ain_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_AIN_MODE
int	ai32ssa_ain_range			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_AIN_RANGE
int	ai32ssa_auto_cal_sts		(int fd, int index, int verbose, s32* get);						// AI32SSA_IOCTL_AUTO_CAL_STS
int	ai32ssa_auto_calibrate		(int fd, int index, int verbose);								// AI32SSA_IOCTL_AUTO_CALIBRATE
int	ai32ssa_aux_0_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_AUX_0_MODE
int	ai32ssa_aux_1_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_AUX_1_MODE
int	ai32ssa_aux_in_pol			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_AUX_IN_POL
int	ai32ssa_aux_noise			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_AUX_NOISE
int	ai32ssa_aux_out_pol			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_AUX_OUT_POL
int	ai32ssa_aux_sync_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_AUX_SYNC_ENABLE
int	ai32ssa_burst_busy			(int fd, int index, int verbose, s32* get);						// AI32SSA_IOCTL_BURST_BUSY
int	ai32ssa_burst_size			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_BURST_SIZE
int	ai32ssa_burst_src			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_BURST_SRC
int	ai32ssa_chan_active			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_CHAN_ACTIVE
int	ai32ssa_chan_first			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_CHAN_FIRST
int	ai32ssa_chan_last			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_CHAN_LAST
int	ai32ssa_chan_single			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_CHAN_SINGLE
int	ai32ssa_data_format			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_DATA_FORMAT
int	ai32ssa_data_packing		(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_DATA_PACKING
int	ai32ssa_dmdma_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_DMDMA_MODE
int	ai32ssa_initialize			(int fd, int index, int verbose);								// AI32SSA_IOCTL_INITIALIZE
int	ai32ssa_input_sync			(int fd, int index, int verbose);								// AI32SSA_IOCTL_INPUT_SYNC
int	ai32ssa_irq0_sel			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_IRQ0_SEL
int	ai32ssa_irq1_sel			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_IRQ1_SEL
int	ai32ssa_query				(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_QUERY
int	ai32ssa_rag_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_RAG_ENABLE
int	ai32ssa_rag_nrate			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_RAG_NRATE
int	ai32ssa_rbg_clk_src			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_RBG_CLK_SRC
int	ai32ssa_rbg_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_RBG_ENABLE
int	ai32ssa_rbg_nrate			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_RBG_NRATE
int	ai32ssa_reg_mod				(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);	// AI32SSA_IOCTL_REG_MOD
int	ai32ssa_reg_read			(int fd, int index, int verbose, u32 reg, u32* value);			// AI32SSA_IOCTL_REG_READ
int	ai32ssa_reg_write			(int fd, int index, int verbose, u32 reg, u32 value);			// AI32SSA_IOCTL_REG_WRITE
int	ai32ssa_rx_io_abort			(int fd, int index, int verbose, s32* get);						// AI32SSA_IOCTL_RX_IO_ABORT
int	ai32ssa_rx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_RX_IO_MODE
int	ai32ssa_rx_io_overflow		(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_RX_IO_OVERFLOW
int	ai32ssa_rx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_RX_IO_TIMEOUT
int	ai32ssa_rx_io_underflow		(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_RX_IO_UNDERFLOW
int	ai32ssa_samp_clk_src		(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_SAMP_CLK_SRC
int	ai32ssa_scan_marker			(int fd, int index, int verbose, s32 set, s32* get);			// AI32SSA_IOCTL_SCAN_MARKER
int	ai32ssa_scan_marker_val		(int fd, int index, int verbose, u32 set, u32* get);			// AI32SSA_IOCTL_SCAN_MARKER_VAL
int	ai32ssa_wait_cancel			(int fd, int index, int verbose, gsc_wait_t* wait);				// AI32SSA_IOCTL_WAIT_CANCEL
int	ai32ssa_wait_event			(int fd, int index, int verbose, gsc_wait_t* wait);				// AI32SSA_IOCTL_WAIT_EVENT
int	ai32ssa_wait_status			(int fd, int index, int verbose, gsc_wait_t* wait);				// AI32SSA_IOCTL_WAIT_STATUS

// Auxiliary utility services

int	ai32ssa_config_ain			(int fd, int index, int verbose, s32 nrate);
int	ai32ssa_config_aux			(int fd, int index, int verbose);
int ai32ssa_fsamp_ain_report	(int fd, int index, int verbose, int chan, s32* fsamp);
int ai32ssa_fsamp_ain_report_all(int fd, int index, int verbose, s32* fsamp);
int	ai32ssa_id_device			(int fd, int index, int verbose);

int	ai32ssa_count_boards		(int verbose, s32* get);
int	ai32ssa_reg_list			(int fd, int detail);

const gsc_reg_def_t*			ai32ssa_reg_get_def_id			(u32 reg);
const gsc_reg_def_t*			ai32ssa_reg_get_def_index		(int index);
const char*						ai32ssa_reg_get_desc			(u32 reg);
const char*						ai32ssa_reg_get_name			(u32 reg);



#endif
