// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSA/samples/id/perform.c $
// $Rev: 51915 $
// $Date: 2022-10-20 17:28:15 -0500 (Thu, 20 Oct 2022) $

// 16AI32SSA: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _input_modes(void)
{
	gsc_label("Input Modes");
	printf("Differential/Pseudo Differential, Zero Test, +Vref Test\n");
	return(0);
}



//*****************************************************************************
static int _voltage_ranges(void)
{
	gsc_label("Voltage Ranges");
	printf("+-10V, +-5V, +-2.5V or +-2.5, +-1.25, +-0.625\n");
	return(0);
}



//*****************************************************************************
static int _clocking_sources(void)
{
	gsc_label("Clocking Sources");
	printf("Rate Generator(s), External, Software\n");
	return(0);
}



//*****************************************************************************
static int _sampling_modes(void)
{
	gsc_label("Sampling Modes");
	printf("Continuous, Burst, Single Shot\n");
	return(0);
}



//*****************************************************************************
static int _id_device_bcfgr(const args_t* args)
{
	gsc_reg_def_t	list[2]	= { { NULL }, { NULL } };
	gsc_reg_def_t*	ptr;

	int	errs	= 0;

	printf("\n");
	ptr	= (gsc_reg_def_t*) ai32ssa_reg_get_def_id(AI32SSA_GSC_BCFGR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, ai32ssa_reg_read);
	}
	else
	{
		errs++;
		printf(	"FAIL <---  (%d. ai32ssa_reg_get_def_id, AI32SSA_GSC_BCFGR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _register_map(const args_t* args)
{
	int	errs;

	printf("\n");
	errs	= ai32ssa_reg_list(args->fd, args->detail);
	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	int	i;

	gsc_label("Device Features");
	printf("\n");

	gsc_label_level_inc();

	errs	+= _input_modes();
	errs	+= _voltage_ranges();
	errs	+= _clocking_sources();
	errs	+= _sampling_modes();

	for (i = 0; i < AI32SSA_IOCTL_QUERY_LAST; i++)
		errs	+= ai32ssa_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _id_device_bcfgr(args);
	errs	+= _register_map(args);
	printf("\n");

	return(errs);
}


