// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSA/samples/sbtest/ain_range.c $
// $Rev: 51919 $
// $Date: 2022-10-20 17:31:15 -0500 (Thu, 20 Oct 2022) $

// 16AI32SSA: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	low[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AI32SSA_IOCTL_AIN_RANGE,
			/* arg		*/	AI32SSA_AIN_RANGE_0_625V,
			/* reg		*/	AI32SSA_GSC_BCTLR,
			/* mask		*/	0x30,
			/* value	*/	0x00
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AI32SSA_IOCTL_AIN_RANGE,
			/* arg		*/	AI32SSA_AIN_RANGE_1_25V,
			/* reg		*/	AI32SSA_GSC_BCTLR,
			/* mask		*/	0x30,
			/* value	*/	0x10
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AI32SSA_IOCTL_AIN_RANGE,
			/* arg		*/	AI32SSA_AIN_RANGE_2_5V,
			/* reg		*/	AI32SSA_GSC_BCTLR,
			/* mask		*/	0x30,
			/* value	*/	0x20
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	high[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AI32SSA_IOCTL_AIN_RANGE,
			/* arg		*/	AI32SSA_AIN_RANGE_2_5V,
			/* reg		*/	AI32SSA_GSC_BCTLR,
			/* mask		*/	0x30,
			/* value	*/	0x00
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AI32SSA_IOCTL_AIN_RANGE,
			/* arg		*/	AI32SSA_AIN_RANGE_5V,
			/* reg		*/	AI32SSA_GSC_BCTLR,
			/* mask		*/	0x30,
			/* value	*/	0x10
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AI32SSA_IOCTL_AIN_RANGE,
			/* arg		*/	AI32SSA_AIN_RANGE_10V,
			/* reg		*/	AI32SSA_GSC_BCTLR,
			/* mask		*/	0x30,
			/* value	*/	0x20
		},

		{ SERVICE_END_LIST }
	};

	int						errs	= 0;
	const service_data_t*	list;
	s32						v_range_high;

	errs	+= ai32ssa_query(fd, -1, 0, AI32SSA_QUERY_V_RANGE_HIGH, &v_range_high);
	list	= v_range_high ? high : low;

	errs	+= ai32ssa_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= ai32ssa_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// This test requires additional equipment.
	return(0);
}



/******************************************************************************
*
*	Function:	ain_range_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AI32SSA_IOCTL_AIN_RANGE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ain_range_test(int fd)
{
	int	errs	= 0;

	gsc_label("AI32SSA_IOCTL_AIN_RANGE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


