// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSA/samples/sbtest/aux_sync_enable.c $
// $Rev: 51919 $
// $Date: 2022-10-20 17:31:15 -0500 (Thu, 20 Oct 2022) $

// 16AI32SSA: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AI32SSA_IOCTL_AUX_SYNC_ENABLE,
			/* arg		*/	AI32SSA_AUX_SYNC_ENABLE_NO,
			/* reg		*/	AI32SSA_GSC_BCTLR,
			/* mask		*/	0x80,
			/* value	*/	0x00
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AI32SSA_IOCTL_AUX_SYNC_ENABLE,
			/* arg		*/	AI32SSA_AUX_SYNC_ENABLE_YES,
			/* reg		*/	AI32SSA_GSC_BCTLR,
			/* mask		*/	0x80,
			/* value	*/	0x80
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= ai32ssa_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= ai32ssa_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// This test requires additional equipment.
	return(0);
}



/******************************************************************************
*
*	Function:	aux_sync_enable_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AI32SSA_IOCTL_AUX_SYNC_ENABLE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int aux_sync_enable_test(int fd)
{
	int	errs	= 0;

	gsc_label("AI32SSA_IOCTL_AUX_SYNC_ENABLE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


