// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSA/samples/sbtest/main.h $
// $Rev: 50226 $
// $Date: 2022-02-09 16:15:52 -0600 (Wed, 09 Feb 2022) $

// 16AI32SSA: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <semaphore.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "16ai32ssa_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)			(sizeof((a))/sizeof((a)[0]))



// data types *****************************************************************

typedef enum
{
	SERVICE_END_LIST,	// Ends list of service_data_t structures.
	SERVICE_NORMAL,
	SERVICE_REG_MOD,
	SERVICE_REG_READ,
	SERVICE_REG_SHOW,
	SERVICE_REG_TEST,
	SERVICE_REG_WRITE,
	SERVICE_SLEEP,
	SERVICE_SLEEP_MS,
	SERVICE_IOCTL_GET,
	SERVICE_IOCTL_SET
} service_t;

typedef struct
{
	service_t		service;
	unsigned long	cmd;	// IOCTL code
	s32				arg;	// The IOCTL data argument.
	u32				reg;	// The register to access. Use -1 to ignore.
	u32				mask;	// The register bits of interest.
	u32				value;	// The value expected for the bits of interest.
} service_data_t;



// prototypes *****************************************************************

int	ain_buf_clear_test(int fd);			// AI32SSA_IOCTL_AIN_BUF_CLEAR
int	ain_buf_level_test(int fd);			// AI32SSA_IOCTL_AIN_BUF_LEVEL
int	ain_buf_overflow_test(int fd);		// AI32SSA_IOCTL_AIN_BUF_OVERFLOW
int	ain_buf_thr_lvl_test(int fd);		// AI32SSA_IOCTL_AIN_BUF_THR_LVL
int	ain_buf_thr_sts_test(int fd);		// AI32SSA_IOCTL_AIN_BUF_THR_STS
int	ain_buf_underflow_test(int fd);		// AI32SSA_IOCTL_AIN_BUF_UNDERFLOW
int	ain_mode_test(int fd);				// AI32SSA_IOCTL_AIN_MODE
int	ain_range_test(int fd);				// AI32SSA_IOCTL_AIN_RANGE
int	auto_cal_sts_test(int fd);			// AI32SSA_IOCTL_AUTO_CAL_STS
int	auto_calibrate_test(int fd);		// AI32SSA_IOCTL_AUTO_CALIBRATE
int	aux_0_mode_test(int fd);			// AI32SSA_IOCTL_AUX_0_MODE
int	aux_1_mode_test(int fd);			// AI32SSA_IOCTL_AUX_1_MODE
int	aux_in_pol_test(int fd);			// AI32SSA_IOCTL_AUX_IN_POL
int	aux_noise_test(int fd);				// AI32SSA_IOCTL_AUX_NOISE
int	aux_out_pol_test(int fd);			// AI32SSA_IOCTL_AUX_OUT_POL
int	aux_sync_enable_test(int fd);		// AI32SSA_IOCTL_AUX_SYNC_ENABLE

int	burst_busy_test(int fd);			// AI32SSA_IOCTL_BURST_BUSY
int	burst_size_test(int fd);			// AI32SSA_IOCTL_BURST_SIZE
int	burst_src_test(int fd);				// AI32SSA_IOCTL_BURST_SRC

int	chan_active_test(int fd);			// AI32SSA_IOCTL_CHAN_ACTIVE
int	chan_first_test(int fd);			// AI32SSA_IOCTL_CHAN_FIRST
int	chan_last_test(int fd);				// AI32SSA_IOCTL_CHAN_LAST
int	chan_single_test(int fd);			// AI32SSA_IOCTL_CHAN_SINGLE

int	data_format_test(int fd);			// AI32SSA_IOCTL_DATA_FORMAT
int	data_packing_test(int fd);			// AI32SSA_IOCTL_DATA_PACKING
int	dmdma_mode_test(int fd);			// AI32SSA_IOCTL_DMDMA_MODE

int	initialize_test(int fd);			// AI32SSA_IOCTL_INITIALIZE
int	input_sync_test(int fd);			// AI32SSA_IOCTL_INPUT_SYNC
int	irq0_sel_test(int fd);				// AI32SSA_IOCTL_IRQ0_SEL
int	irq1_sel_test(int fd);				// AI32SSA_IOCTL_IRQ1_SEL

int	perform_tests(int fd);

int	query_test(int fd);					// AI32SSA_IOCTL_QUERY

int	rag_enable_test(int fd);			// AI32SSA_IOCTL_RAG_ENABLE
int	rag_nrate_test(int fd);				// AI32SSA_IOCTL_RAG_NRATE
int	rbg_clk_src_test(int fd);			// AI32SSA_IOCTL_RBG_CLK_SRC
int	rbg_enable_test(int fd);			// AI32SSA_IOCTL_RBG_ENABLE
int	rbg_nrate_test(int fd);				// AI32SSA_IOCTL_RBG_NRATE
int	reg_mod_test(int fd);				// AI32SSA_IOCTL_REG_MOD
int	reg_read_test(int fd);				// AI32SSA_IOCTL_REG_READ
int	reg_write_test(int fd);				// AI32SSA_IOCTL_REG_WRITE

int	rx_io_abort_test(int fd);			// AI32SSA_IOCTL_RX_IO_ABORT
int	rx_io_mode_test(int fd);			// AI32SSA_IOCTL_RX_IO_MODE
int	rx_io_overflow_test(int fd);		// AI32SSA_IOCTL_RX_IO_OVERFLOW
int	rx_io_timeout_test(int fd);			// AI32SSA_IOCTL_RX_IO_TIMEOUT
int	rx_io_underflow_test(int fd);		// AI32SSA_IOCTL_RX_IO_UNDERFLOW

int	samp_clk_src_test(int fd);			// AI32SSA_IOCTL_SAMP_CLK_SRC
int	scan_marker_test(int fd);			// AI32SSA_IOCTL_SCAN_MARKER
int	scan_marker_val_test(int fd);		// AI32SSA_IOCTL_SCAN_MARKER_VAL
int	service_ioctl_reg_get_list(int fd, const service_data_t* list);
int	service_ioctl_set_get_list(int fd, const service_data_t* list);
int	service_ioctl_set_reg_list(int fd, const service_data_t* list);

int	wait_cancel_test(int fd);			// AI32SSA_IOCTL_WAIT_CANCEL
int	wait_event_test(int fd);			// AI32SSA_IOCTL_WAIT_EVENT
int	wait_status_test(int fd);			// AI32SSA_IOCTL_WAIT_STATUS



#endif
