// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSA/samples/sbtest/perform.c $
// $Rev: 50226 $
// $Date: 2022-02-09 16:15:52 -0600 (Wed, 09 Feb 2022) $

// 16AI32SSA: Sample Application: source file

#include "main.h"



//*****************************************************************************
int perform_tests(int fd)
{
	int	errs	= 0;

	errs	+= reg_read_test(fd);				// AI32SSA_IOCTL_REG_READ
	errs	+= reg_write_test(fd);				// AI32SSA_IOCTL_REG_WRITE
	errs	+= reg_mod_test(fd);				// AI32SSA_IOCTL_REG_MOD
	errs	+= query_test(fd);					// AI32SSA_IOCTL_QUERY
	errs	+= initialize_test(fd);				// AI32SSA_IOCTL_INITIALIZE
	errs	+= auto_calibrate_test(fd);			// AI32SSA_IOCTL_AUTO_CALIBRATE
	errs	+= auto_cal_sts_test(fd);			// AI32SSA_IOCTL_AUTO_CAL_STS
	errs	+= ain_buf_clear_test(fd);			// AI32SSA_IOCTL_AIN_BUF_CLEAR
	errs	+= ain_buf_level_test(fd);			// AI32SSA_IOCTL_AIN_BUF_LEVEL
	errs	+= ain_buf_overflow_test(fd);		// AI32SSA_IOCTL_AIN_BUF_OVERFLOW
	errs	+= ain_buf_thr_lvl_test(fd);		// AI32SSA_IOCTL_AIN_BUF_THR_LVL
	errs	+= ain_buf_thr_sts_test(fd);		// AI32SSA_IOCTL_AIN_BUF_THR_STS
	errs	+= ain_buf_underflow_test(fd);		// AI32SSA_IOCTL_AIN_BUF_UNDERFLOW
	errs	+= ain_mode_test(fd);				// AI32SSA_IOCTL_AIN_MODE
	errs	+= ain_range_test(fd);				// AI32SSA_IOCTL_AIN_RANGE
	errs	+= aux_0_mode_test(fd);				// AI32SSA_IOCTL_AUX_0_MODE
	errs	+= aux_1_mode_test(fd);				// AI32SSA_IOCTL_AUX_1_MODE
	errs	+= aux_in_pol_test(fd);				// AI32SSA_IOCTL_AUX_IN_POL
	errs	+= aux_noise_test(fd);				// AI32SSA_IOCTL_AUX_NOISE
	errs	+= aux_out_pol_test(fd);			// AI32SSA_IOCTL_AUX_OUT_POL
	errs	+= aux_sync_enable_test(fd);		// AI32SSA_IOCTL_AUX_SYNC_ENABLE
	errs	+= burst_busy_test(fd);				// AI32SSA_IOCTL_BURST_BUSY
	errs	+= burst_size_test(fd);				// AI32SSA_IOCTL_BURST_SIZE
	errs	+= burst_src_test(fd);				// AI32SSA_IOCTL_BURST_SRC
	errs	+= chan_active_test(fd);			// AI32SSA_IOCTL_CHAN_ACTIVE
	errs	+= chan_first_test(fd);				// AI32SSA_IOCTL_CHAN_FIRST
	errs	+= chan_last_test(fd);				// AI32SSA_IOCTL_CHAN_LAST
	errs	+= chan_single_test(fd);			// AI32SSA_IOCTL_CHAN_SINGLE
	errs	+= data_format_test(fd);			// AI32SSA_IOCTL_DATA_FORMAT
	errs	+= data_packing_test(fd);			// AI32SSA_IOCTL_DATA_PACKING
	errs	+= dmdma_mode_test(fd);				// AI32SSA_IOCTL_DMDMA_MODE
	errs	+= input_sync_test(fd);				// AI32SSA_IOCTL_INPUT_SYNC
	errs	+= irq0_sel_test(fd);				// AI32SSA_IOCTL_IRQ0_SEL
	errs	+= irq1_sel_test(fd);				// AI32SSA_IOCTL_IRQ1_SEL
	errs	+= rag_enable_test(fd);				// AI32SSA_IOCTL_RAG_ENABLE
	errs	+= rag_nrate_test(fd);				// AI32SSA_IOCTL_RAG_NRATE
	errs	+= rbg_clk_src_test(fd);			// AI32SSA_IOCTL_RBG_CLK_SRC
	errs	+= rbg_enable_test(fd);				// AI32SSA_IOCTL_RBG_ENABLE
	errs	+= rbg_nrate_test(fd);				// AI32SSA_IOCTL_RBG_NRATE
	errs	+= rx_io_abort_test(fd);			// AI32SSA_IOCTL_RX_IO_ABORT
	errs	+= rx_io_mode_test(fd);				// AI32SSA_IOCTL_RX_IO_MODE
	errs	+= rx_io_overflow_test(fd);			// AI32SSA_IOCTL_RX_IO_OVERFLOW
	errs	+= rx_io_timeout_test(fd);			// AI32SSA_IOCTL_RX_IO_TIMEOUT
	errs	+= rx_io_underflow_test(fd);		// AI32SSA_IOCTL_RX_IO_UNDERFLOW
	errs	+= samp_clk_src_test(fd);			// AI32SSA_IOCTL_SAMP_CLK_SRC
	errs	+= scan_marker_test(fd);			// AI32SSA_IOCTL_SCAN_MARKER
	errs	+= scan_marker_val_test(fd);		// AI32SSA_IOCTL_SCAN_MARKER_VAL
	errs	+= wait_cancel_test(fd);			// AI32SSA_IOCTL_WAIT_CANCEL
	errs	+= wait_event_test(fd);				// AI32SSA_IOCTL_WAIT_EVENT
	errs	+= wait_status_test(fd);			// AI32SSA_IOCTL_WAIT_STATUS

	return(errs);
}


