// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSA/samples/sbtest/query.c $
// $Rev: 51919 $
// $Date: 2022-10-20 17:31:15 -0500 (Thu, 20 Oct 2022) $

// 16AI32SSA: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	// There are no bits to test.
	return(0);
}



//*****************************************************************************
static int _function_test(int fd)
{
	s32	data;
	s32	count;
	int	errs;
	int	i;

	errs	= ai32ssa_query(fd, -1, 0, AI32SSA_QUERY_COUNT, &count);

	if (count != (AI32SSA_IOCTL_QUERY_LAST + 1))
	{
		errs	= 1;
		printf(	"FAIL <---  (expected %ld, got %ld, rebuild application)\n",
				(long) AI32SSA_IOCTL_QUERY_LAST + 1,
				(long) count);
	}
	else
	{
		for (i = 0; (errs == 0) && (i <= AI32SSA_IOCTL_QUERY_LAST); i++)
			errs	= ai32ssa_query(fd, -1, 0, i, &data);
	}

	return(errs);
}



/******************************************************************************
*
*	Function:	query_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AI32SSA_IOCTL_QUERY.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int query_test(int fd)
{
	int	errs	= 0;

	gsc_label("AI32SSA_IOCTL_QUERY");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


