// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSA/samples/signals/perform.c $
// $Rev: 51920 $
// $Date: 2022-10-20 17:31:33 -0500 (Thu, 20 Oct 2022) $

// 16AI32SSA: Sample Application: source file

#include "main.h"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;

	gsc_label("Input Configuration");
	printf("\n");

	gsc_label_level_inc();

	errs	+= ai32ssa_initialize	(args->fd, -1, 1);

	errs	+= ai32ssa_samp_clk_src	(args->fd, -1, 1, AI32SSA_SAMP_CLK_SRC_RAG,		NULL);
	errs	+= ai32ssa_rag_nrate	(args->fd, -1, 1, 1000,							NULL);
	errs	+= ai32ssa_rag_enable	(args->fd, -1, 1, AI32SSA_GEN_ENABLE_YES,		NULL);
	errs	+= ai32ssa_burst_src	(args->fd, -1, 1, AI32SSA_BURST_SRC_RBG,		NULL);
	errs	+= ai32ssa_rbg_nrate	(args->fd, -1, 1, 5000,							NULL);
	errs	+= ai32ssa_rbg_clk_src	(args->fd, -1, 1, AI32SSA_RBG_CLK_SRC_MASTER,	NULL);
	errs	+= ai32ssa_rbg_enable	(args->fd, -1, 1, AI32SSA_GEN_ENABLE_YES,		NULL);
	errs	+= ai32ssa_burst_size	(args->fd, -1, 1, 4,							NULL);

	gsc_label_level_dec();

	gsc_label("Auxiliary Configuration");
	printf("\n");
	gsc_label_level_inc();

	errs	+= ai32ssa_aux_noise	(args->fd, -1, 1, AI32SSA_AUX_NOISE_HIGH,		NULL);
	errs	+= ai32ssa_aux_out_pol	(args->fd, -1, 1, AI32SSA_AUX_OUT_POL_HI_PULSE,	NULL);
	errs	+= ai32ssa_aux_0_mode	(args->fd, -1, 1, AI32SSA_AUX_MODE_OUTPUT,		NULL);
	errs	+= ai32ssa_aux_1_mode	(args->fd, -1, 1, AI32SSA_AUX_MODE_OUTPUT,		NULL);

	gsc_label_level_dec();

	// Wait a bit.
	gsc_label("Waiting");
	os_sleep_ms(args->seconds * 1000);
	printf("Done\n");

	errs	+= ai32ssa_initialize	(args->fd, -1, 1);
	return(errs);
}



