// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSA/utils/util_ain_buf_level.c $
// $Rev: 43893 $
// $Date: 2018-10-30 15:16:50 -0500 (Tue, 30 Oct 2018) $

// 16AI32SSA: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai32ssa_ain_buf_level
*
*	Purpose:
*
*		Provide a visual wrapper for the AI32SSA_IOCTL_AIN_BUF_LEVEL service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		get		The current setting is recorded here, if not NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int	ai32ssa_ain_buf_level(int fd, int index, int verbose, s32* get)
{
	int		errs	= 0;
	int		ret;
	s32		set;

	if (verbose)
		gsc_label_index("Input Buffer Level", index);

	ret		= ai32ssa_ioctl(fd, AI32SSA_IOCTL_AIN_BUF_LEVEL, &set);
	errs	+= ret ? 1 : 0;

	if (verbose)
	{
		printf("%s  (", errs ? "FAIL <---" : "PASS");
		gsc_label_long_comma(get[0]);
		printf(" 32-bit data items)\n");
	}

	if (get)
		get[0]	= set;

	return(errs);
}


