// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSA/utils/util_ain_buf_thr_sts.c $
// $Rev: 43893 $
// $Date: 2018-10-30 15:16:50 -0500 (Tue, 30 Oct 2018) $

// 16AI32SSA: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai32ssa_ain_buf_thr_sts
*
*	Purpose:
*
*		Provide a visual wrapper for the AI32SSA_IOCTL_AIN_BUF_THR_STS service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		get		The current setting is recorded here, if not NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai32ssa_ain_buf_thr_sts(int fd, int index, int verbose, s32* get)
{
	char	buf[128];
	int		errs	= 0;
	int		ret;
	s32		set		= -1;

	if (verbose)
		gsc_label_index("Input Buffer Threshold", index);

	ret		= ai32ssa_ioctl(fd, AI32SSA_IOCTL_AIN_BUF_THR_STS, &set);
	errs	+= ret ? 1 : 0;

	switch (get[0])
	{
		default:

			sprintf(buf, "INVALID: %ld", (long) get[0]);
			break;

		case AI32SSA_AIN_BUF_THR_STS_CLEAR:

			strcpy(buf, "Clear");
			break;

		case AI32SSA_AIN_BUF_THR_STS_SET:

			strcpy(buf, "Set");
			break;
	}

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", buf);

	if (get)
		get[0]	= set;

	return(errs);
}


