// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI32SSA/utils/util_scan_marker_val.c $
// $Rev: 43893 $
// $Date: 2018-10-30 15:16:50 -0500 (Tue, 30 Oct 2018) $

// 16AI32SSA: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai32ssa_scan_marker_val
*
*	Purpose:
*
*		Provide a visual wrapper for the AI32SSA_IOCTL_SCAN_MARKER_VAL service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		The setting to apply.
*
*		get		The current setting is recorded here, if not NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int	ai32ssa_scan_marker_val(int fd, int index, int verbose, u32 set, u32* get)
{
	int	errs	= 0;
	int	ret;

	if (verbose)
		gsc_label_index("Scan Marker Value", index);

	ret		= ai32ssa_ioctl(fd, AI32SSA_IOCTL_SCAN_MARKER_VAL, &set);
	errs	+= ret ? 1 : 0;

	if (verbose)
		printf("%s  (0x%08lX)\n", errs ? "FAIL <---" : "PASS", (long) set);

	if (get)
		get[0]	= set;

	return(errs);
}


